Loading...
Searching...
No Matches
wayland::touch_t Class Reference

touchscreen input device More...

`#include <wayland-client-protocol.hpp>`

Inheritance diagram for wayland::touch_t:
[legend]
Collaboration diagram for wayland::touch_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

void | release ()
| release the touch object
bool | can_release () const
| Check whether the release function is available with the currently bound version of the protocol.
std::function< void(uint32_t, uint32_t, surface_t, int32_t, double, double)> & | on_down ()
| touch down event and beginning of a touch sequence
std::function< void(uint32_t, uint32_t, int32_t)> & | on_up ()
| end of a touch event sequence
std::function< void(uint32_t, int32_t, double, double)> & | on_motion ()
| update of touch point coordinates
std::function< void()> & | on_frame ()
| end of touch frame event
std::function< void()> & | on_cancel ()
| touch session cancelled
std::function< void(int32_t, double, double)> & | on_shape ()
| update shape of touch point
std::function< void(int32_t, double)> & | on_orientation ()
| update orientation of touch point
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Static Public Attributes

static constexpr std::uint32_t | release_since_version = 3
| Minimum protocol version required for the release function.

## Detailed Description

touchscreen input device

The wl_touch interface represents a touchscreen associated with a seat.

Touch interactions can consist of one or more contacts. For each contact, a series of events is generated, starting with a down event, followed by zero or more motion events, and ending with an up event. Events relating to the same contact point can be identified by the ID of the sequence.

Definition at line 3298 of file wayland-client-protocol.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 117 of file wayland-client.hpp.

## Member Function Documentation

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## can_release()

bool touch_t::can_release | ( |  | ) | const

Check whether the release function is available with the currently bound version of the protocol.

Definition at line 3243 of file wayland-client-protocol.cpp.

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 303 of file wayland-client.hpp.

## on_cancel()

std::function< void()> & touch_t::on_cancel | ( |  | ) |

touch session cancelled

Sent if the compositor decides the touch stream is a global gesture. No further events are sent to the clients from that particular gesture. Touch cancellation applies to all touch points currently active on this client's surface. The client is responsible for finalizing the touch points, future touch points on this surface may reuse the touch point ID.

Definition at line 3269 of file wayland-client-protocol.cpp.

## on_down()

std::function< void(uint32_t, uint32_t, surface_t, int32_t, double, double)> & touch_t::on_down | ( |  | ) |

touch down event and beginning of a touch sequence

Parameters

  serial | serial number of the touch down event
  time | timestamp with millisecond granularity
  surface | surface touched
  id | the unique ID of this touch point
  x | surface-local x coordinate
  y | surface-local y coordinate

A new touch point has appeared on the surface. This touch point is assigned a unique ID. Future events from this touch point reference this ID. The ID ceases to be valid after a touch up event and may be reused in the future.

Definition at line 3249 of file wayland-client-protocol.cpp.

## on_frame()

std::function< void()> & touch_t::on_frame | ( |  | ) |

end of touch frame event

Indicates the end of a set of events that logically belong together. A client is expected to accumulate the data in all events within the frame before proceeding.

A wl_touch.frame terminates at least one event but otherwise no guarantee is provided about the set of events within a frame. A client must assume that any state not updated in a frame is unchanged from the previously known state.

Definition at line 3264 of file wayland-client-protocol.cpp.

## on_motion()

std::function< void(uint32_t, int32_t, double, double)> & touch_t::on_motion | ( |  | ) |

update of touch point coordinates

Parameters

  time | timestamp with millisecond granularity
  id | the unique ID of this touch point
  x | surface-local x coordinate
  y | surface-local y coordinate

A touch point has changed coordinates.

Definition at line 3259 of file wayland-client-protocol.cpp.

## on_orientation()

std::function< void(int32_t, double)> & touch_t::on_orientation | ( |  | ) |

update orientation of touch point

Parameters

  id | the unique ID of this touch point
  orientation | angle between major axis and positive surface y-axis in degrees

Sent when a touchpoint has changed its orientation.

This event does not occur on its own. It is sent before a wl_touch.frame event and carries the new shape information for any previously reported, or new touch points of that frame.

Other events describing the touch point such as wl_touch.down, wl_touch.motion or wl_touch.shape may be sent within the same wl_touch.frame. A client should treat these events as a single logical touch point update. The order of wl_touch.shape, wl_touch.orientation and wl_touch.motion is not guaranteed. A wl_touch.down event is guaranteed to occur before the first wl_touch.orientation event for this touch ID but both events may occur within the same wl_touch.frame.

The orientation describes the clockwise angle of a touchpoint's major axis to the positive surface y-axis and is normalized to the -180 to +180 degree range. The granularity of orientation depends on the touch device, some devices only support binary rotation values between 0 and 90 degrees.

This event is only sent by the compositor if the touch device supports orientation reports.

Definition at line 3279 of file wayland-client-protocol.cpp.

## on_shape()

std::function< void(int32_t, double, double)> & touch_t::on_shape | ( |  | ) |

update shape of touch point

Parameters

  id | the unique ID of this touch point
  major | length of the major axis in surface-local coordinates
  minor | length of the minor axis in surface-local coordinates

Sent when a touchpoint has changed its shape.

This event does not occur on its own. It is sent before a wl_touch.frame event and carries the new shape information for any previously reported, or new touch points of that frame.

Other events describing the touch point such as wl_touch.down, wl_touch.motion or wl_touch.orientation may be sent within the same wl_touch.frame. A client should treat these events as a single logical touch point update. The order of wl_touch.shape, wl_touch.orientation and wl_touch.motion is not guaranteed. A wl_touch.down event is guaranteed to occur before the first wl_touch.shape event for this touch ID but both events may occur within the same wl_touch.frame.

A touchpoint shape is approximated by an ellipse through the major and minor axis length. The major axis length describes the longer diameter of the ellipse, while the minor axis length describes the shorter diameter. Major and minor are orthogonal and both are specified in surface-local coordinates. The center of the ellipse is always at the touchpoint location as reported by wl_touch.down or wl_touch.move.

This event is only sent by the compositor if the touch device supports shape reports. The client has to make reasonable assumptions about the shape if it did not receive this event.

Definition at line 3274 of file wayland-client-protocol.cpp.

## on_up()

std::function< void(uint32_t, uint32_t, int32_t)> & touch_t::on_up | ( |  | ) |

end of a touch event sequence

Parameters

  serial | serial number of the touch up event
  time | timestamp with millisecond granularity
  id | the unique ID of this touch point

The touch point has disappeared. No further events will be sent for this touch point and the touch point's ID is released and may be reused in a future touch down event.

Definition at line 3254 of file wayland-client-protocol.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## release()

void touch_t::release | ( |  | ) |

release the touch object

Definition at line 3238 of file wayland-client-protocol.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

## Member Data Documentation

## release_since_version

std::uint32_t wayland::touch_t::release_since_version = 3

static constexpr

Minimum protocol version required for the release function.

Definition at line 3334 of file wayland-client-protocol.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol.cpp